<template>
  <section
    class="relative flex items-center flex-col pt-10 pb-4 px-4 container-form-login"
  >
    <p v-if="error" class="text-xs text-800 mb-3">{{ error }}</p>
    <form @submit.prevent="submit" class="w-full">
      <!-- input username login -->
      <ReaderInput
        v-model="username"
        label="Username"
        name="username"
        inputtype="text"
        link="http://www.w3.org/2000/svg"
        view="0 0 24 24"
        path="M12 12c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4zm0 2c-2.67 0-8 1.34-8 4v2h16v-2c0-2.66-5.33-4-8-4z"
        v-bind:classes="[
          this.error
            ? 'appearance-none block w-full bg-600 text-300 border border-1 border-800 pb-3 pt-5 pl-11 mb-3 leading-tight focus:outline-none focus:border-800 rounded-full peer'
            : 'appearance-none block w-full bg-600 text-300 border border-1 border-600 pb-3 pt-5 pl-11 mb-3 leading-tight focus:outline-none focus:border-400 rounded-full peer',
        ]"
        v-bind:classeslabel="[
          this.username !== ''
            ? 'absolute left-11 text-gray-600 cursor-text text-xs top-1 transition-all'
            : 'absolute left-11 top-4 small:top-[1.15rem] text-gray-600 cursor-text peer-focus:text-xs peer-focus:top-1 transition-all base:text-sm small:text-xs',
        ]"
      />

      <!-- input password login -->
      <ReaderInput
        v-model="password"
        label="Password"
        name="password"
        inputtype="password"
        link="http://www.w3.org/2000/svg"
        view="0 0 24 24"
        path="M18 8h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zm-6 9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zm3.1-9H8.9V6c0-1.71 1.39-3.1 3.1-3.1 1.71 0 3.1 1.39 3.1 3.1v2z"
        v-bind:classes="[
          this.error
            ? 'appearance-none block w-full bg-600 text-300 border border-1 border-800 pb-3 pt-5 pl-11 mb-3 leading-tight focus:outline-none focus:border-800 rounded-full peer'
            : 'appearance-none block w-full bg-600 text-300 border border-1 border-600 pb-3 pt-5 pl-11 mb-3 leading-tight focus:outline-none focus:border-400 rounded-full peer',
        ]"
        v-bind:classeslabel="[
          this.password !== ''
            ? 'absolute left-11 text-gray-600 cursor-text text-xs top-1 transition-all'
            : 'absolute left-11 top-4 small:top-[1.15rem] text-gray-600 cursor-text peer-focus:text-xs peer-focus:top-1 transition-all base:text-sm small:text-xs',
        ]"
      />

      <!-- button login -->
      <button
        class="w-full py-4 bg-400 font-medium text-100 rounded-full text-base base:text-sm small:text-xs"
      >
        Masuk
      </button>
    </form>
  </section>
</template>

<script>
import ReaderInput from "../../../common/ReaderInput.vue";
import { useRouter } from "vue-router";
import axios from "axios";

export default {
  name: "FormLogin",
  components: {
    ReaderInput,
  },

  data() {
    return {
      username: "",
      password: "",
      error: "",
    };
  },

  setup() {
    const router = useRouter();
    return { router };
  },

  methods: {
    async submit(e) {
      const form = new FormData(e.target);
      const inputs = {
        username: this.username,
        password: this.password,
        expiresInMins: 59,
      };
      try {
        const { data } = await axios.post("auth/login", inputs, {
          headers: {
            "Access-Control-Allow-Credentials": true,
          },
        });
        axios.defaults.headers.common["Authorization"] = `Bearer ${data.token}`;
        axios.defaults.headers.common["x-access-token"] = data.token;
        localStorage.setItem("credentials", JSON.stringify(data));
        await this.router.push("/loggedin");
      } catch (err) {
        if (this.username === "" && this.password === "") {
          this.error = "Form tidak boleh kosong";
        } else if (this.username === "") {
          this.error = "Form tidak boleh kosong";
        } else if (this.password === "") {
          this.error = "Form tidak boleh kosong";
        } else {
          console.log(err);
          this.error = "Invalid data";
        }
      }
    },
  },
};
</script>
